using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Diagnostics;
using Globals;
using novapiLib90;
using System.Collections.Generic;

namespace CSharpConverter
{


    /// <summary>
    /// Summary description for Form1.
    /// </summary>
    public class Form1 : System.Windows.Forms.Form
    {

        // These are the Win32 error code for file not found or access denied.
        const int ERROR_FILE_NOT_FOUND = 2;
        const int ERROR_ACCESS_DENIED = 5;


		const string PRINTER_NAME = "novaPDF SDK 9";
        const string SMALL_SIZE_PROFILE = "Small Size Profile";
        const string FULL_OPT_PROFILE = "Full Options Profile";
        const int PROFILE_IS_PUBLIC = 0;

        String newSmallSizeProfileId = String.Empty;
        String newFullSizeProfileId = String.Empty;

        private NovaPdfOptions90Class mobjNovaOptios;
        private List<KeyValuePair<String, String>> profilesList;

        private System.Windows.Forms.OpenFileDialog openFileDialog1;
        private System.Windows.Forms.Button btnStartPrinting;
        private System.Windows.Forms.Button btnBrowse;
        private System.Windows.Forms.ComboBox cmbProfiles;
        private System.Windows.Forms.Label label1;
        private System.Windows.Forms.GroupBox groupBox1;
        private System.Windows.Forms.CheckBox chkCompress;
        private System.Windows.Forms.CheckBox chkEmbedFonts;
        private System.Windows.Forms.CheckBox chkDetectLinks;
        private System.Windows.Forms.GroupBox groupBox2;
        private System.Windows.Forms.TextBox txtTitle;
        private System.Windows.Forms.Label label2;
        private System.Windows.Forms.TextBox txtSubject;
        private System.Windows.Forms.Label label3;
        private System.Windows.Forms.GroupBox groupBox3;
        private System.Windows.Forms.Label label4;
        private System.Windows.Forms.TextBox txtFilename;
        private System.Windows.Forms.GroupBox groupBox4;
        private System.Windows.Forms.TextBox txtFileToConvert;
        private System.Windows.Forms.Button btnCancel;
        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.Container components = null;

        public Form1()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();

            //
            // TODO: Add any constructor code after InitializeComponent call
            //
        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.btnStartPrinting = new System.Windows.Forms.Button();
            this.btnBrowse = new System.Windows.Forms.Button();
            this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
            this.cmbProfiles = new System.Windows.Forms.ComboBox();
            this.label1 = new System.Windows.Forms.Label();
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.chkDetectLinks = new System.Windows.Forms.CheckBox();
            this.chkEmbedFonts = new System.Windows.Forms.CheckBox();
            this.chkCompress = new System.Windows.Forms.CheckBox();
            this.groupBox2 = new System.Windows.Forms.GroupBox();
            this.label3 = new System.Windows.Forms.Label();
            this.txtSubject = new System.Windows.Forms.TextBox();
            this.label2 = new System.Windows.Forms.Label();
            this.txtTitle = new System.Windows.Forms.TextBox();
            this.groupBox3 = new System.Windows.Forms.GroupBox();
            this.txtFilename = new System.Windows.Forms.TextBox();
            this.label4 = new System.Windows.Forms.Label();
            this.groupBox4 = new System.Windows.Forms.GroupBox();
            this.txtFileToConvert = new System.Windows.Forms.TextBox();
            this.btnCancel = new System.Windows.Forms.Button();
            this.groupBox1.SuspendLayout();
            this.groupBox2.SuspendLayout();
            this.groupBox3.SuspendLayout();
            this.groupBox4.SuspendLayout();
            this.SuspendLayout();
            // 
            // btnStartPrinting
            // 
            this.btnStartPrinting.Location = new System.Drawing.Point(400, 288);
            this.btnStartPrinting.Name = "btnStartPrinting";
            this.btnStartPrinting.Size = new System.Drawing.Size(80, 24);
            this.btnStartPrinting.TabIndex = 10;
            this.btnStartPrinting.Text = "Start Printing";
            this.btnStartPrinting.Click += new System.EventHandler(this.btnStartPrinting_Click);
            // 
            // btnBrowse
            // 
            this.btnBrowse.Location = new System.Drawing.Point(472, 16);
            this.btnBrowse.Name = "btnBrowse";
            this.btnBrowse.Size = new System.Drawing.Size(64, 24);
            this.btnBrowse.TabIndex = 9;
            this.btnBrowse.Text = "Browse";
            this.btnBrowse.Click += new System.EventHandler(this.btnBrowse_Click);
            // 
            // cmbProfiles
            // 
            this.cmbProfiles.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.cmbProfiles.Location = new System.Drawing.Point(16, 24);
            this.cmbProfiles.Name = "cmbProfiles";
            this.cmbProfiles.Size = new System.Drawing.Size(168, 21);
            this.cmbProfiles.TabIndex = 0;
            this.cmbProfiles.SelectedIndexChanged += new System.EventHandler(this.cmbProfiles_SelectedIndexChanged);
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(16, 8);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(120, 16);
            this.label1.TabIndex = 3;
            this.label1.Text = "Select Profile:";
            // 
            // groupBox1
            // 
            this.groupBox1.Controls.Add(this.chkDetectLinks);
            this.groupBox1.Controls.Add(this.chkEmbedFonts);
            this.groupBox1.Controls.Add(this.chkCompress);
            this.groupBox1.Location = new System.Drawing.Point(16, 56);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(144, 88);
            this.groupBox1.TabIndex = 4;
            this.groupBox1.TabStop = false;
            this.groupBox1.Text = "Options";
            // 
            // chkDetectLinks
            // 
            this.chkDetectLinks.Location = new System.Drawing.Point(16, 64);
            this.chkDetectLinks.Name = "chkDetectLinks";
            this.chkDetectLinks.Size = new System.Drawing.Size(112, 16);
            this.chkDetectLinks.TabIndex = 3;
            this.chkDetectLinks.Text = "Detect Links";
            // 
            // chkEmbedFonts
            // 
            this.chkEmbedFonts.Location = new System.Drawing.Point(16, 40);
            this.chkEmbedFonts.Name = "chkEmbedFonts";
            this.chkEmbedFonts.Size = new System.Drawing.Size(104, 16);
            this.chkEmbedFonts.TabIndex = 2;
            this.chkEmbedFonts.Text = "Embed Fonts";
            // 
            // chkCompress
            // 
            this.chkCompress.Location = new System.Drawing.Point(16, 16);
            this.chkCompress.Name = "chkCompress";
            this.chkCompress.Size = new System.Drawing.Size(96, 16);
            this.chkCompress.TabIndex = 1;
            this.chkCompress.Text = "Compress";
            // 
            // groupBox2
            // 
            this.groupBox2.Controls.Add(this.label3);
            this.groupBox2.Controls.Add(this.txtSubject);
            this.groupBox2.Controls.Add(this.label2);
            this.groupBox2.Controls.Add(this.txtTitle);
            this.groupBox2.Location = new System.Drawing.Point(176, 56);
            this.groupBox2.Name = "groupBox2";
            this.groupBox2.Size = new System.Drawing.Size(392, 88);
            this.groupBox2.TabIndex = 5;
            this.groupBox2.TabStop = false;
            this.groupBox2.Text = "Doc Info";
            // 
            // label3
            // 
            this.label3.Location = new System.Drawing.Point(8, 58);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(48, 16);
            this.label3.TabIndex = 3;
            this.label3.Text = "Subject:";
            // 
            // txtSubject
            // 
            this.txtSubject.Location = new System.Drawing.Point(64, 56);
            this.txtSubject.Name = "txtSubject";
            this.txtSubject.Size = new System.Drawing.Size(312, 20);
            this.txtSubject.TabIndex = 5;
            // 
            // label2
            // 
            this.label2.Location = new System.Drawing.Point(8, 26);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(48, 16);
            this.label2.TabIndex = 1;
            this.label2.Text = "Title:";
            // 
            // txtTitle
            // 
            this.txtTitle.Location = new System.Drawing.Point(64, 24);
            this.txtTitle.Name = "txtTitle";
            this.txtTitle.Size = new System.Drawing.Size(312, 20);
            this.txtTitle.TabIndex = 4;
            // 
            // groupBox3
            // 
            this.groupBox3.Controls.Add(this.txtFilename);
            this.groupBox3.Controls.Add(this.label4);
            this.groupBox3.Location = new System.Drawing.Point(16, 160);
            this.groupBox3.Name = "groupBox3";
            this.groupBox3.Size = new System.Drawing.Size(552, 48);
            this.groupBox3.TabIndex = 6;
            this.groupBox3.TabStop = false;
            this.groupBox3.Text = "PDF Name";
            // 
            // txtFilename
            // 
            this.txtFilename.Location = new System.Drawing.Point(79, 20);
            this.txtFilename.Name = "txtFilename";
            this.txtFilename.Size = new System.Drawing.Size(457, 20);
            this.txtFilename.TabIndex = 6;
            // 
            // label4
            // 
            this.label4.Location = new System.Drawing.Point(16, 22);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(64, 16);
            this.label4.TabIndex = 0;
            this.label4.Text = "File Name:";
            // 
            // groupBox4
            // 
            this.groupBox4.Controls.Add(this.txtFileToConvert);
            this.groupBox4.Controls.Add(this.btnBrowse);
            this.groupBox4.Location = new System.Drawing.Point(16, 224);
            this.groupBox4.Name = "groupBox4";
            this.groupBox4.Size = new System.Drawing.Size(552, 48);
            this.groupBox4.TabIndex = 7;
            this.groupBox4.TabStop = false;
            this.groupBox4.Text = "File to convert ";
            // 
            // txtFileToConvert
            // 
            this.txtFileToConvert.Location = new System.Drawing.Point(16, 18);
            this.txtFileToConvert.Name = "txtFileToConvert";
            this.txtFileToConvert.Size = new System.Drawing.Size(440, 20);
            this.txtFileToConvert.TabIndex = 8;
            // 
            // btnCancel
            // 
            this.btnCancel.Location = new System.Drawing.Point(488, 288);
            this.btnCancel.Name = "btnCancel";
            this.btnCancel.Size = new System.Drawing.Size(72, 24);
            this.btnCancel.TabIndex = 11;
            this.btnCancel.Text = "Cancel";
            this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(576, 325);
            this.Controls.Add(this.btnCancel);
            this.Controls.Add(this.groupBox4);
            this.Controls.Add(this.groupBox3);
            this.Controls.Add(this.groupBox2);
            this.Controls.Add(this.groupBox1);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.cmbProfiles);
            this.Controls.Add(this.btnStartPrinting);
            this.Name = "Form1";
            this.Text = "C# Converter";
            this.Load += new System.EventHandler(this.Form1_Load);
            this.FormClosing += new System.Windows.Forms.FormClosingEventHandler(this.Form1_FormClosing);
            this.groupBox1.ResumeLayout(false);
            this.groupBox2.ResumeLayout(false);
            this.groupBox2.PerformLayout();
            this.groupBox3.ResumeLayout(false);
            this.groupBox3.PerformLayout();
            this.groupBox4.ResumeLayout(false);
            this.groupBox4.PerformLayout();
            this.ResumeLayout(false);

        }

        void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            mobjNovaOptios.DeleteProfile(newFullSizeProfileId);
            mobjNovaOptios.DeleteProfile(newSmallSizeProfileId);
        }
        #endregion

        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            Application.Run(new Form1());
        }

        private void btnStartPrinting_Click(object sender, System.EventArgs e)
        {
            UpdateProfileFromDialog();

            if (txtFileToConvert.Text.Trim() == "")
            {
                MessageBox.Show("No file to convert!");
                return;
            }
            
            mobjNovaOptios.SetActiveProfile(profilesList[cmbProfiles.SelectedIndex].Value);
            
            mobjNovaOptios.SetDefaultPrinter();

            mobjNovaOptios.LicenseShellExecuteFile(txtFileToConvert.Text);

            Process myProcess = new Process();

            try
            {

                myProcess.StartInfo.FileName = txtFileToConvert.Text;
                myProcess.StartInfo.Verb = "Print";
                myProcess.StartInfo.CreateNoWindow = true;
                myProcess.StartInfo.WindowStyle = ProcessWindowStyle.Hidden;
                myProcess.Start();
            }
            catch (Win32Exception ex)
            {
                if (ex.NativeErrorCode == ERROR_FILE_NOT_FOUND)
                {
                    Console.WriteLine(ex.Message + ". Check the path and filename");
                }

                else if (ex.NativeErrorCode == ERROR_ACCESS_DENIED)
                {
                    // Note that if your word processor might generate exceptions
                    // such as this, which are handled first.
                    Console.WriteLine(ex.Message + ". You do not have permission to print this file.");
                }
            }
            myProcess.WaitForExit(10000);
            myProcess.Close();
            mobjNovaOptios.RestoreDefaultPrinter();
        }


        private void btnBrowse_Click(object sender, System.EventArgs e)
        {
            System.Windows.Forms.DialogResult prntDialogResult = openFileDialog1.ShowDialog();

            txtFileToConvert.Text = openFileDialog1.FileName;
        }

        private void Form1_Load(object sender, System.EventArgs e)
        {
            try
            {
                mobjNovaOptios = new NovaPdfOptions90Class();
                profilesList = new List<KeyValuePair<string, string>>();

                // initialize the NovaPdfOptions object
                // if you have an application license for novaPDF SDK,
                // pass the license key to the Initialize() function
                // mobjNovaOptios.Initialize(PRINTER_NAME, "<license key>");
                mobjNovaOptios.Initialize(PRINTER_NAME, "");

                cmbProfiles.Items.Clear();
                AddSmallProfile();
                AddFullProfile();

                string strProfile;
                string strActiveProfile=String.Empty;

                // get the active profile ...
                try
                {
                    mobjNovaOptios.GetActiveProfile(out strActiveProfile);
                }
                catch (System.Runtime.InteropServices.COMException exc)
                {
                    // ignore profile exists error
                    if (NovaErrors.NV_NO_ACTIVE_PROFILE == (uint)exc.ErrorCode)
                    {
                        System.Console.WriteLine("The printer does not have an active profile");
                    }
                    else
                    {
                        // more	serious	error, propagate it
                        throw exc;
                    }
                }

                try
                {
                    mobjNovaOptios.GetFirstProfile(out strProfile);

                    String name = String.Empty;

                    mobjNovaOptios.LoadProfile(strProfile);
                    mobjNovaOptios.GetOptionString(NovaOptions.NOVAPDF_PROFILE_NAME, out name); 

                    profilesList.Add(new KeyValuePair<string,string>(name, strProfile));
                    //int curr = cmbProfiles.Items.Add(strProfile);
                    int curr = cmbProfiles.Items.Add(name);

                    if (strProfile == strActiveProfile) cmbProfiles.SelectedIndex = curr;
                    while (true)
                    {
                        mobjNovaOptios.GetNextProfile(out strProfile);

                        mobjNovaOptios.LoadProfile(strProfile);
                        mobjNovaOptios.GetOptionString(NovaOptions.NOVAPDF_PROFILE_NAME, out name);

                        profilesList.Add(new KeyValuePair<string, string>(name, strProfile));
                        //curr = cmbProfiles.Items.Add(strProfile);
                        curr = cmbProfiles.Items.Add(name);
                        if (strProfile == strActiveProfile) cmbProfiles.SelectedIndex = curr;
                    }
                }
                catch (System.Runtime.InteropServices.COMException ComException)
                {
                    if (((~ComException.ErrorCode ^ NovaErrors.NV_NO_MORE_PROFILES) ^ 0xFFFFFFFF) != 0)
                    {
                        throw ComException;
                    }
                }
                if (cmbProfiles.SelectedIndex < 0) cmbProfiles.SelectedIndex = 0;
                UpdateDialogFromProfile();
            }
            catch (Exception ex)
            {
                System.Diagnostics.Debug.WriteLine(ex.Message);
            }

        }

        private void AddSmallProfile()
        {
            try
            {
                // mark start changing options
                //mobjNovaOptios.StartUpdateProfiles();

                
                // Set some options to this profile
                mobjNovaOptios.AddProfile(SMALL_SIZE_PROFILE, PROFILE_IS_PUBLIC, out newSmallSizeProfileId);

                //load the new profile
                mobjNovaOptios.LoadProfile(newSmallSizeProfileId);

                // disable the "Save PDF file as" prompt
                mobjNovaOptios.SetOptionLong(NovaOptions.NOVAPDF_SAVE_PROMPT_TYPE, 0);
                // set generated Pdf files destination folder  "c:\"
                mobjNovaOptios.SetOptionString(NovaOptions.NOVAPDF_SAVE_FOLDER, "c:\\");
                // set output file name
                mobjNovaOptios.SetOptionString(NovaOptions.NOVAPDF_SAVE_FILE_NAME, "PDF Converter small size.pdf");
                // if file exists in the destination folder, append a counter to the end of the file name
                mobjNovaOptios.SetOptionLong(NovaOptions.NOVAPDF_SAVE_FILEEXIST_ACTION, (int)SaveFileConflictType.FILE_CONFLICT_STRATEGY_AUTONUMBER_NEW);
                // don't detect URLs
                mobjNovaOptios.SetOptionBool(NovaOptions.NOVAPDF_URL_ANALIZE, 0);

                // Set image compresion method to JPEG and quality to 75, possible values are from 10 to 100
                mobjNovaOptios.SetOptionBool(NovaOptions.NOVAPDF_COMPRESS_ENABLE, 1);
                mobjNovaOptios.SetOptionBool(NovaOptions.NOVAPDF_COMPRESS_HIGH_COLOR,1);
                mobjNovaOptios.SetOptionLong(NovaOptions.NOVAPDF_COMPRESS_HIGH_COLOR_LEVEL, 75);

                // make sure text compression is enabled, and set compression level to 9  maximum   posible values are 1-9
                mobjNovaOptios.SetOptionBool(NovaOptions.NOVAPDF_COMPRESS_TEXT_GRAPHICS, 1);
                mobjNovaOptios.SetOptionLong(NovaOptions.NOVAPDF_COMPRESS_TEXT_GRAPHICS_LEVEL, 9);

                // disable unused font embeding
                mobjNovaOptios.SetOptionBool(NovaOptions.NOVAPDF_FONTS_EMBED_ALL_USED_FONTS, 0);

                // mark finish changing options so they are saved for the printer
                mobjNovaOptios.SaveProfile();
            }
            catch (System.Runtime.InteropServices.COMException ComException)
            {
                //if (((~ComException.ErrorCode ^ NovaErrors.NV_PROFILE_EXISTS) ^ 0xFFFFFFFF) == 0)
                //{
                //    System.Diagnostics.Debug.WriteLine("Profile \"Small Size Profile\" exists");
                //}
                //else
                {
                    MessageBox.Show("Error creating Small Size Profile:\r\n" + ComException.Message);
                    System.Diagnostics.Debug.WriteLine(ComException.Message);
                }
            }
        }
        private void AddFullProfile()
        {
            try
            {
                // mark start changing options
                //mobjNovaOptios.StartUpdateProfiles();

               
                // Set some options to this profile
                mobjNovaOptios.AddProfile(FULL_OPT_PROFILE, PROFILE_IS_PUBLIC, out newFullSizeProfileId);

                //load the new profile
                mobjNovaOptios.LoadProfile(newFullSizeProfileId);

                // disable the "Save PDF file as" prompt
                mobjNovaOptios.SetOptionLong(NovaOptions.NOVAPDF_SAVE_PROMPT_TYPE, 0);
                // set generated Pdf files destination folder  "c:\"
                mobjNovaOptios.SetOptionString(NovaOptions.NOVAPDF_SAVE_FOLDER, "c:\\");
                // set output file name "[N] full", the [N] macro means document name
                mobjNovaOptios.SetOptionString(NovaOptions.NOVAPDF_SAVE_FILE_NAME, "[N] full");
                // if file exists in the destination folder, append a counter to the end of the file name
                mobjNovaOptios.SetOptionLong(NovaOptions.NOVAPDF_SAVE_FILEEXIST_ACTION, (int)SaveFileConflictType.FILE_CONFLICT_STRATEGY_AUTONUMBER_NEW);
                // enable URL detection
                mobjNovaOptios.SetOptionBool(NovaOptions.NOVAPDF_URL_ANALIZE, 1);
                // set image JPEG quality to 100  maximum
                mobjNovaOptios.SetOptionBool(NovaOptions.NOVAPDF_COMPRESS_ENABLE, 1);
                mobjNovaOptios.SetOptionLong(NovaOptions.NOVAPDF_COMPRESS_HIGH_COLOR_TYPE, (int)CompressionMethod.COMPRESS_METHOD_JPEG);
                mobjNovaOptios.SetOptionLong(NovaOptions.NOVAPDF_COMPRESS_HIGH_COLOR_LEVEL, 100);
             
                mobjNovaOptios.SetOptionBool(NovaOptions.NOVAPDF_COMPRESS_TEXT_GRAPHICS, 1);
                mobjNovaOptios.SetOptionLong(NovaOptions.NOVAPDF_COMPRESS_TEXT_GRAPHICS_LEVEL, 6);
                // enable font files embedding
                mobjNovaOptios.SetOptionBool(NovaOptions.NOVAPDF_FONTS_EMBED_ALL_USED_FONTS, 1);
                // mark finish changing options so they are saved for the printer
                // mark finish changing options so they are saved for the printer
                mobjNovaOptios.SaveProfile();
            }
            catch (System.Runtime.InteropServices.COMException ComException)
            {
                //if (((~ComException.ErrorCode ^ NovaErrors.NV_PROFILE_EXISTS) ^ 0xFFFFFFFF) == 0)
                //{
                //    System.Diagnostics.Debug.WriteLine("Profile \"Small Size Profile\" exists");
                //}
                //else
                {
                    MessageBox.Show("Error creating Full Size Profile:\r\n" + ComException.Message);
                    System.Diagnostics.Debug.WriteLine(ComException.Message);
                }
            }
        }
        private void UpdateDialogFromProfile()
        {
            int intValue = 0;
            string strProfile = "";
            try
            {
                // mark start changing options
                //mobjNovaOptios.StartUpdateProfiles();

                strProfile = profilesList[cmbProfiles.SelectedIndex].Value;
                //strProfile = profilesList[(string)cmbProfiles.SelectedItem.ToString()];
                
                //load the new profile
                mobjNovaOptios.LoadProfile(strProfile);

                mobjNovaOptios.GetOptionBool(NovaOptions.NOVAPDF_COMPRESS_TEXT_GRAPHICS, out intValue);
                chkCompress.CheckState = intValue == 1 ? CheckState.Checked : CheckState.Unchecked;
                mobjNovaOptios.GetOptionBool(NovaOptions.NOVAPDF_URL_ANALIZE, out intValue);
                chkDetectLinks.CheckState = intValue == 1 ? CheckState.Checked : CheckState.Unchecked;
                mobjNovaOptios.GetOptionBool(NovaOptions.NOVAPDF_FONTS_EMBED_ALL_USED_FONTS, out intValue);
                chkEmbedFonts.CheckState = intValue == 1 ? CheckState.Checked : CheckState.Unchecked;
                string strValue;
                mobjNovaOptios.GetOptionString(NovaOptions.NOVAPDF_SAVE_FILE_NAME, out strValue);
                txtFilename.Text = strValue;
                mobjNovaOptios.GetOptionString(NovaOptions.NOVAPDF_DOCINFO_SUBJECT, out strValue);
                txtSubject.Text = strValue;
                mobjNovaOptios.GetOptionString2(NovaOptions.NOVAPDF_DOCINFO_TITLE, out strValue);
                txtTitle.Text = strValue;
                // mark finish changing options so they are saved for the printer
                //mobjNovaOptios.EndUpdateProfiles();
            }
            catch (Exception e)
            {
                MessageBox.Show("Error retrieving profile \"" + strProfile + "\" options:\r\n" + e.Message);
                System.Diagnostics.Debug.WriteLine(e.Message);
            }
        }

        private void UpdateProfileFromDialog()
        {
            string strProfile;

            //strProfile = (string)cmbProfiles.SelectedItem.ToString();
            strProfile = profilesList[cmbProfiles.SelectedIndex].Value;

            //load the new profile
            mobjNovaOptios.LoadProfile(strProfile);

            try
            {
                // mark start changing options
                //mobjNovaOptios.StartUpdateProfiles();
                mobjNovaOptios.SetOptionBool(NovaOptions.NOVAPDF_COMPRESS_TEXT_GRAPHICS, chkCompress.CheckState == CheckState.Checked ? 1 : 0);
                mobjNovaOptios.SetOptionBool(NovaOptions.NOVAPDF_URL_ANALIZE, chkDetectLinks.CheckState == CheckState.Checked ? 1 : 0);
                mobjNovaOptios.SetOptionBool(NovaOptions.NOVAPDF_FONTS_EMBED_ALL_USED_FONTS, chkEmbedFonts.CheckState == CheckState.Checked ? 1 : 0);
                mobjNovaOptios.SetOptionString(NovaOptions.NOVAPDF_SAVE_FILE_NAME, txtFilename.Text);
                mobjNovaOptios.SetOptionString(NovaOptions.NOVAPDF_DOCINFO_SUBJECT, txtSubject.Text);
                mobjNovaOptios.SetOptionString(NovaOptions.NOVAPDF_DOCINFO_TITLE, txtTitle.Text);
                // mark finish changing options so they are saved for the printer
                //mobjNovaOptios.EndUpdateProfiles();
                //save the new added profile
                mobjNovaOptios.SaveProfile();
            }
            catch (Exception e)
            {
                MessageBox.Show("Error saving profile \"" + strProfile + "\" options:\r\n" + e.Message);
                System.Diagnostics.Debug.WriteLine(e.Message);
            }
        }

        private void cmbProfiles_SelectedIndexChanged(object sender, System.EventArgs e)
        {
            UpdateDialogFromProfile();
        }

        private void btnCancel_Click(object sender, System.EventArgs e)
        {
            mobjNovaOptios.DeleteProfile(newSmallSizeProfileId);
            mobjNovaOptios.DeleteProfile(newFullSizeProfileId);
            this.Close();
        }

    }
}
